<ion-header>
  <ion-toolbar color="primary">
    <ion-buttons slot="start">
      <ion-back-button></ion-back-button>
    </ion-buttons>
    <ion-title>
      Compliant Acceptance Details
    </ion-title>
    <ion-buttons slot="end" style="font-size: 1.8rem;" routerDirection="root" routerLink="/home">
      <ion-icon name="home"></ion-icon>
    </ion-buttons>
    <!-- <ion-buttons (click)="refreshPage()" slot="end" style="font-size: 1.8rem;">
      <ion-icon name="refresh"></ion-icon>
    </ion-buttons> -->
  </ion-toolbar>
</ion-header>
<ion-content>
  <mat-vertical-stepper [linear]="isLinear" #stepper>
    <!-- Detail Tab -->
    <mat-step [stepControl]="detailFormGroup">
      <form [formGroup]="detailFormGroup" class="example-form">
        <ng-template matStepLabel>Details</ng-template>
        <!-- complaint_no -->
        <mat-form-field class="example-full-width">
          <mat-label>Complaint No.</mat-label>
          <input matInput [disabled]='true' [(ngModel)]="service.complaintno" [ngModelOptions]="{standalone: true}">
        </mat-form-field>
        <!-- complaint_date -->
        <mat-form-field class="example-full-width">
          <mat-label>Complaint Date</mat-label>
          <input matInput [disabled]='true' [(ngModel)]="service.complaintdate" [ngModelOptions]="{standalone: true}">
        </mat-form-field>
        <!-- Document Type -->
        <mat-form-field class="example-full-width">
          <mat-label>Document Type</mat-label>
          <input matInput [disabled]='true' [(ngModel)]="service.doctype[0].name" [ngModelOptions]="{standalone: true}">
        </mat-form-field>
        <!-- Name of Complainer -->
        <mat-form-field class="example-full-width">
          <mat-label>Name of Complainer</mat-label>
          <input matInput formControlName="nameOfComplainerCtrl" [(ngModel)]="service.nameofcomplainer">
        </mat-form-field>
        <!-- Designation of Complainer -->
        <mat-form-field class="example-full-width">
          <mat-label>Designation of Complainer</mat-label>
          <input matInput formControlName="desigOfComplainerCtrl" [(ngModel)]="service.desofcomplnr[0].name">
        </mat-form-field>
        <!-- Contact No -->
        <mat-form-field class="example-full-width">
          <mat-label>Contact No</mat-label>
          <input matInput formControlName="mobilenoCtrl" [(ngModel)]="service.contnumber">
          <div padding-left>
            <ng-container *ngFor="let validation of validation_messages.mobileno">
              <div *ngIf="detailFormGroup.get('mobilenoCtrl').hasError(validation.type) && detailsStepValid">
                <p style="color: red;font-size: small;">{{validation.message}}</p>
              </div>
            </ng-container>
          </div>
        </mat-form-field>
        <!-- Email ID -->
        <mat-form-field class="example-full-width">
          <mat-label>Email ID</mat-label>
          <input matInput formControlName="emailIDCtrl" [(ngModel)]="service.email">
          <div padding-left>
            <ng-container *ngFor="let validation of validation_messages.email">
              <div *ngIf="detailFormGroup.get('emailIDCtrl').hasError(validation.type) && detailsStepValid">
                <p style="color: red;font-size: small;">{{validation.message}}</p>
              </div>
            </ng-container>
          </div>
        </mat-form-field>
        <!-- Event Date -->
        <mat-form-field class="example-full-width">
          <mat-label>Event Date</mat-label>
          <input matInput [disabled]='true' [(ngModel)]="service.eventdate" [ngModelOptions]="{standalone: true}">
        </mat-form-field>
        <!-- Complaint Description -->
        <mat-form-field class="example-full-width">
          <mat-label>Complaint Description</mat-label>
          <input matInput formControlName="complaintDescriptionCtrl" [(ngModel)]="service.description">
          <div padding-left>
            <ng-container *ngFor="let validation of validation_messages.complaintDescription">
              <div
                *ngIf="detailFormGroup.get('complaintDescriptionCtrl').hasError(validation.type) && detailsStepValid">
                <p style="color: red;font-size: small;">{{validation.message}}</p>
              </div>
            </ng-container>
          </div>
        </mat-form-field>
        <div>
          <button mat-button matStepperNext (click)="matDetailSettper($event)">Next</button>
        </div>
      </form>
    </mat-step>
    <!-- Product Compliant Tab-->
    <mat-step [stepControl]="productCompliantFormGroup" *ngIf="isProductCompliantTab">
      <form [formGroup]="productCompliantFormGroup" class="example-form">
        <ng-template matStepLabel>Product Compliant</ng-template>
        <!-- Lot No -->
        <mat-form-field class="example-full-width">
          <mat-label>Lot No.</mat-label>
          <input matInput formControlName="lotNoCtrl">
        </mat-form-field>
        <div>
          <button mat-button matStepperPrevious>Back</button>
          <button mat-button matStepperNext (click)="matSettperProductCompliant($event)">Next</button>
        </div>
      </form>
    </mat-step>
    <!-- Consumables Tab  -->
    <mat-step [stepControl]="consumablesFormGroup" *ngIf="isConsumablesTab">
      <form [formGroup]="consumablesFormGroup" class="example-form">
        <ng-template matStepLabel>Consumables</ng-template>
        <!-- Lot No -->
        <mat-form-field class="example-full-width">
          <mat-label>Lot No.</mat-label>
          <input matInput formControlName="lotNoConsumablesCtrl">
        </mat-form-field>
        <div>
          <button mat-button matStepperPrevious>Back</button>
          <button mat-button matStepperNext (click)="matSettperConsumables($event)">Next</button>
        </div>
      </form>
    </mat-step>
    <!-- Equiment Tab-->
    <mat-step [stepControl]="equimentFormGroup" *ngIf="isEquimentTab">
      <form [formGroup]="equimentFormGroup" class="example-form">
        <ng-template matStepLabel>Equiment</ng-template>
        <!-- Serial No -->
        <mat-form-field class="example-full-width">
          <mat-label>Serial No.</mat-label>
          <input matInput formControlName="serialNoCtrl" [(ngModel)]="service.serialno">
          <div padding-left>
            <ng-container *ngFor="let validation of validation_messages.serialNo">
              <div *ngIf="equimentFormGroup.get('serialNoCtrl').hasError(validation.type) && equimentStepValid">
                <p style="color: red;font-size: small;">{{validation.message}}</p>
              </div>
            </ng-container>
          </div>
        </mat-form-field>
        <!-- Contract Type -->
        <mat-form-field class="example-full-width">
          <mat-label>Contract Type</mat-label>
          <input matInput [disabled]='true' [(ngModel)]="contracttype" [ngModelOptions]="{standalone: true}">
        </mat-form-field>
        <!-- Invoice No -->
        <mat-form-field class="example-full-width">
          <mat-label>Invoice No.</mat-label>
          <input matInput [disabled]='true' [(ngModel)]="service.invoiceno" [ngModelOptions]="{standalone: true}">
        </mat-form-field>
        <!-- Invoice Date -->
        <mat-form-field class="example-full-width">
          <mat-label>Invoice Date</mat-label>
          <input matInput [disabled]='true' [(ngModel)]="service.invoicedate" [ngModelOptions]="{standalone: true}">
        </mat-form-field>
        <!-- Error Code -->
        <mat-form-field class="example-full-width">
          <mat-label>Error Code</mat-label>
            <input matInput [disabled]='true' [(ngModel)]="service.errorcode[0].code" [ngModelOptions]="{standalone: true}">  
        </mat-form-field>
        <!-- Dealer Name -->
        <mat-form-field class="example-full-width">
          <mat-label>Dealer Name</mat-label>
          <input matInput formControlName="dealerNameCtrl" [(ngModel)]="service.dealername">
        </mat-form-field>
         <!-- New Dealer Name
         <mat-form-field class="example-full-width">
          <mat-label>Dealer Name</mat-label>
          <input matInput formControlName="newDealerNameCtrl" [(ngModel)]="service.newdealername">
        </mat-form-field> -->
        
        <!-- Sales Representative -->
        <mat-form-field class="example-full-width">
          <mat-label>Sales Representative</mat-label>
          <input matInput [disabled]='true' [(ngModel)]="service.salesrep"
            [ngModelOptions]="{standalone: true}">
        </mat-form-field>
        <!-- Installation Date -->
         <mat-form-field class="example-full-width">
          <mat-label>Installation Date</mat-label>
          <input matInput [disabled]='true' [(ngModel)]="service.installationdate"
            [ngModelOptions]="{standalone: true}">
        </mat-form-field>
        <div>
          <button mat-button matStepperPrevious>Back</button>
          <button mat-button matStepperNext (click)="matSettperEquiment($event)">Next</button>
        </div>
      </form>
    </mat-step>
    <!-- SKU Details Tab-->
    <mat-step [stepControl]="skuDetailsFormGroup">
      <form [formGroup]="skuDetailsFormGroup" class="example-form">
        <ng-template matStepLabel>SKU Details</ng-template>
        <mat-form-field class="example-full-width">
          <mat-label>SKU Code</mat-label>
          <input matInput [disabled]='true' [(ngModel)]="service.skucode" [ngModelOptions]="{standalone: true}">
        </mat-form-field>
        <!-- SKU Name / Description -->
        <mat-form-field class="example-full-width">
          <mat-label>SKU Name / Description</mat-label>
          <input matInput [disabled]='true' [(ngModel)]="service.skuname" [ngModelOptions]="{standalone: true}">
        </mat-form-field>
        <!-- Brand Name -->
        <mat-form-field class="example-full-width">
          <mat-label>Brand Name</mat-label>
          <input matInput [disabled]='true' [(ngModel)]="service.brandname" [ngModelOptions]="{standalone: true}">
        </mat-form-field>
        <!-- Product to be returned -->
        <mat-form-field class="example-full-width">
          <mat-label>Product to be returned</mat-label>
          <mat-select [disabled]='true' [(ngModel)]="productToBeReturn" [ngModelOptions]="{standalone: true}">
            <mat-option value="Yes">Yes</mat-option>
            <mat-option value="No">No</mat-option>
          </mat-select>
        </mat-form-field>
        <div>
          <button mat-button matStepperPrevious>Back</button>
          <button mat-button matStepperNext (click)="matSettperSKUDetails($event)">Next</button>
        </div>
      </form>
    </mat-step>
    <!-- Customer Detail Tab -->
    <mat-step [stepControl]="customerDetailFormGroup">
      <form [formGroup]="customerDetailFormGroup" class="example-form">
        <ng-template matStepLabel>Customer Detail</ng-template>
        <!-- Customer Name -->
        <mat-form-field class="example-full-width">
          <mat-label>Customer Name</mat-label>
          <input matInput [disabled]='true' [(ngModel)]="service.custname" [ngModelOptions]="{standalone: true}">
        </mat-form-field>
        <!-- Customer Address 1 -->
        <mat-form-field class="example-full-width">
          <mat-label>Customer Address 1</mat-label>
          <input matInput formControlName="customerAddress1Ctrl" [(ngModel)]="service.add1">
          <div padding-left>
            <ng-container *ngFor="let validation of validation_messages.customerAddress1">
              <div
                *ngIf="customerDetailFormGroup.get('customerAddress1Ctrl').hasError(validation.type) && customerDetailStepValid">
                <p style="color: red;font-size: small;">{{validation.message}}</p>
              </div>
            </ng-container>
          </div>
        </mat-form-field>
        <!-- Customer Address 2 -->
        <mat-form-field class="example-full-width">
          <mat-label>Customer Address 2</mat-label>
          <input matInput formControlName="customerAddress2Ctrl" [(ngModel)]="service.add2">
          <div padding-left>
            <ng-container *ngFor="let validation of validation_messages.customerAddress2">
              <div
                *ngIf="customerDetailFormGroup.get('customerAddress2Ctrl').hasError(validation.type) && customerDetailStepValid">
                <p style="color: red;font-size: small;">{{validation.message}}</p>
              </div>
            </ng-container>
          </div>
        </mat-form-field>
        <!-- Customer Address 3 -->
        <mat-form-field class="example-full-width">
          <mat-label>Customer Address 3</mat-label>
          <input matInput formControlName="customerAddress3Ctrl" [(ngModel)]="service.add3">
          <div padding-left>
            <ng-container *ngFor="let validation of validation_messages.customerAddress3">
              <div
                *ngIf="customerDetailFormGroup.get('customerAddress3Ctrl').hasError(validation.type) && customerDetailStepValid">
                <p style="color: red;font-size: small;">{{validation.message}}</p>
              </div>
            </ng-container>
          </div>
        </mat-form-field>
        <!-- Pin Code -->
        <mat-form-field class="example-full-width">
          <mat-label>Pin Code</mat-label>
          <input type="number" matInput formControlName="pinCodeCtrl" [(ngModel)]="service.pincode">
          <div padding-left>
            <ng-container *ngFor="let validation of validation_messages.pinCode">
              <div
                *ngIf="customerDetailFormGroup.get('pinCodeCtrl').hasError(validation.type) && customerDetailStepValid">
                <p style="color: red;font-size: small;">{{validation.message}}</p>
              </div>
            </ng-container>
          </div>
        </mat-form-field>
        <!-- Area -->
        <mat-form-field class="example-full-width">
          <mat-label>Area</mat-label>
          <input matInput [disabled]='true' formControlName="areaCtrl">
        </mat-form-field>
        <!-- City -->
        <mat-form-field class="example-full-width">
          <mat-label>City</mat-label>
          <input matInput [disabled]='true' formControlName="cityCtrl">
        </mat-form-field>
        <!-- State -->
        <mat-form-field class="example-full-width">
          <mat-label>State</mat-label>
          <input matInput [disabled]='true' formControlName="stateCtrl">
        </mat-form-field>
        <!-- Country -->
        <mat-form-field class="example-full-width">
          <mat-label>Country</mat-label>
          <input matInput [disabled]='true' formControlName="countryCtrl">
        </mat-form-field>
        <!-- Service Engineer Name -->
        <mat-form-field class="example-full-width">
          <mat-label>Service Engineer Name</mat-label>
            <mat-select formControlName="serviceEngineerNameCtrl" [(ngModel)]="serviceEngSelected"
                (selectionChange)="serviceEngSelectedChange(serviceEngSelected)">
               <mat-option *ngFor="let serviceEngObj of serviceEngList" [value]="serviceEngObj">
                  {{serviceEngObj.name}}
              </mat-option>
            </mat-select>
        </mat-form-field>
         <!--Service Engineer Contact No -->
         <mat-form-field class="example-full-width">
          <mat-label>Contact No</mat-label>
          <input matInput formControlName="serviceEngMobilenoCtrl">
          <div padding-left>
            <ng-container *ngFor="let validation of validation_messages.mobileno">
              <div *ngIf="customerDetailFormGroup.get('serviceEngMobilenoCtrl').hasError(validation.type) && detailsStepValid">
                <p style="color: red;font-size: small;">{{validation.message}}</p>
              </div>
            </ng-container>
          </div>
        </mat-form-field>
        <!-- Date of Visit -->
        <div class="example-full-width bottom-border">
          <ion-label style="color: darkgray;">Date of Visit</ion-label>
          <section class="cus">
           <!-- <ion-datetime  style="--padding-start:0px" displayFormat="DD-MM-YYYY"  formControlName="dateOfVisitCtrl" max="2050-12-31" [min]="maxDate | date:'yyyy-MM-dd'">
          </ion-datetime>
          <ion-icon name="calendar"></ion-icon>  -->
          <ion-item>
            <ion-input placeholder="Select Date" [value]="datevisit"></ion-input>
            <ion-button fill="clear" id="open-date-input-1">
              <ion-icon icon="calendar"></ion-icon>
            </ion-button>
            <ion-popover class="dateTimePopover" trigger="open-date-input-1" show-backdrop="false">
              <ng-template>
                <ion-datetime
                  #popoverDatetime2
                  formControlName="dateOfVisitCtrl" 
                  max="2050-12-31" [min]="maxDate | date:'yyyy-MM-dd'"
                  presentation="date"
                  showDefaultButtons="true"
                  (ionChange)="datevisit = formatDate(popoverDatetime2.value)"
                ></ion-datetime>
              </ng-template>
            </ion-popover>
          </ion-item>
        </section>
        </div>
        <div padding-left>
          <ng-container *ngFor="let validation of validation_messages.dateOfVisitCtrlErrorMessage">
            <div *ngIf="customerDetailFormGroup.get('serviceVendorRemarksCtrl').hasError(validation.type) && detailsStepValid">
              <p style="color: red;font-size: small;">{{validation.message}}</p>
            </div>
          </ng-container>
        </div>

        <!-- <mat-form-field class="example-full-width">
          <mat-label>Date of Visit</mat-label>
          <input type="date" matInput formControlName="dateOfVisitCtrl" [min]="maxDate | date:'yyyy-MM-dd'">
          <div padding-left>
            <ng-container *ngFor="let validation of validation_messages.dateOfVisitCtrlErrorMessage">
              <div *ngIf="customerDetailFormGroup.get('serviceVendorRemarksCtrl').hasError(validation.type) && detailsStepValid">
                <p style="color: red;font-size: small;">{{validation.message}}</p>
              </div>
            </ng-container>
          </div>
        </mat-form-field> -->
        <!-- Service Vendor Remarks -->
        <mat-form-field class="example-full-width">
          <mat-label>Service Vendor Remarks</mat-label>
          <input matInput formControlName="serviceVendorRemarksCtrl" [(ngModel)]="service.service_vendor_remarks">
          <div padding-left>
            <ng-container *ngFor="let validation of validation_messages.serviceVendorRemarksCtrlErrorMessage">
              <div *ngIf="customerDetailFormGroup.get('serviceVendorRemarksCtrl').hasError(validation.type) && detailsStepValid">
                <p style="color: red;font-size: small;">{{validation.message}}</p>
              </div>
            </ng-container>
          </div>
        </mat-form-field>
        <div>
          <ion-row>
            <ion-col size="6" size-lg="3" no-padding>
              <ion-button size="default" [disabled]="!customerDetailFormGroup.controls.serviceVendorRemarksCtrl.valid" expand="block" color="primary" (click)="submit($event,'Reject')">Reject Complaint</ion-button>
            </ion-col>
            <ion-col size="6" size-lg="3" no-padding>
              <ion-button size="default" [disabled]="!customerDetailFormGroup.valid" expand="block" color="primary" (click)="submit($event,'Accept')">Accept Complaint
              </ion-button>
            </ion-col>
          </ion-row>
        </div>
       
      </form>
    </mat-step>
  </mat-vertical-stepper>
</ion-content>